/****************************************************************************
**
** Copyright (C) 2003-2006 Frank Hemer <frank@hemer.org>,
**                         Tilo Riemer <riemer@crossvc.com>
**
**
**----------------------------------------------------------------------------
**
**----------------------------------------------------------------------------
**
** CrossVC is available under two different licenses:
**
** If CrossVC is linked against the GPLed version of Qt 
** CrossVC is released under the terms of GPL also.
**
** If CrossVC is linked against a nonGPLed version of Qt 
** CrossVC is released under the terms of the 
** CrossVC License for non-Unix platforms (CLNU)
**
**
** CrossVC License for non-Unix platforms (CLNU):
**
** Redistribution and use in binary form, without modification, 
** are permitted provided that the following conditions are met:
**
** 1. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 2. It is not permitted to distribute the binary package under a name
**    different than CrossVC.
** 3. The name of the authors may not be used to endorse or promote
**    products derived from this software without specific prior written
**    permission.
** 4. The source code is the creative property of the authors.
**    Extensions and development under the terms of the Gnu Public License
**    are limited to the Unix platform. Any distribution or compilation of 
**    the source code against libraries licensed other than gpl requires 
**    the written permission of the authors.
**
**
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR 
** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
** ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY 
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
** GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
** WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
** NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
**
**
** CrossVC License for Unix platforms:
**
** This program is free software; you can redistribute it and/or modify 
** it under the terms of the GNU General Public License as published by 
** the Free Software Foundation, version 2 of the License.
** This program is distributed in 
** the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
** even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
** PARTICULAR PURPOSE.
**
** See the GNU General Public License version 2 for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
*****************************************************************************/

#include "config.h"

#include <qtimer.h>
#include <qmessagebox.h>
#include <qwhatsthis.h>
#include <qpushbutton.h>

#include "globals.h"
#include "UpdateOtherRevisionStdDialogImpl.h"
#include "RevisionWidgetImpl.h"

UpdateOtherRevisionStdDialogImpl::UpdateOtherRevisionStdDialogImpl(bool dirOnly,
        QStringList * list, QString moduleName,
        QString caption,
	const QIconSet &whatsThisIconSet,
	QWidget * parent, const char * name, bool modal, WFlags f )
//  : UpdateOtherRevisionStdDialog(LookAndFeel::g_b0AsParent ? 0 : parent,name,modal,f),
  : UpdateOtherRevisionStdDialog(modal ? parent : (LookAndFeel::g_b0AsParent ? 0 : parent),
				 name,modal,f),
    m_stickyTagState(TRUE) {

  m_pWhatsThis->setIconSet(whatsThisIconSet);
#ifdef Q_WS_MAC
  m_pWhatsThis->setMaximumWidth(m_pWhatsThis->height() * 2);
#else
  m_pWhatsThis->setMaximumWidth(m_pWhatsThis->height());
#endif

  setCaption(caption);
  if (dirOnly) {
    revisionWidgetImpl->hideRevisionFrame();
  }
  revisionWidgetImpl->init(parent,list,moduleName);
  QTimer::singleShot(0,this,SLOT(updateSize()));
}

UpdateOtherRevisionStdDialogImpl::~UpdateOtherRevisionStdDialogImpl () {

}

QSize UpdateOtherRevisionStdDialogImpl::sizeHint () const {
  QSize s = UpdateOtherRevisionStdDialog::sizeHint();
  s.setWidth(UpdateOtherRevisionStdDialog::width());
  return s;
}

void UpdateOtherRevisionStdDialogImpl::updateSize() {
  adjustSize();
}

QString UpdateOtherRevisionStdDialogImpl::cvsParameter() {

   QString param = "";
   
   if ( useStickyTag() ) {
      if ( resetStickyTag() ) param = "-A";
      else {
         QString txt = revisionWidgetImpl->getRevision();
         if (!txt.isNull()) {
            param += "-r " + txt;
         } else {
            txt = revisionWidgetImpl->getTag();
            if (!txt.isEmpty()) param += "-r " + txt;
            txt = revisionWidgetImpl->getDateTime();
            if (!txt.isEmpty()) {
               if (!param.isEmpty()) param += " ";
               param += " -D \"" + txt + "\"";
            }
         }
      }
   } else {
      QString txt = revisionWidgetImpl->getRevision();
      if (!txt.isNull()) {
         param += txt;
      } else {
         txt = revisionWidgetImpl->getTag();
         if (!txt.isEmpty()) param += txt;
         txt = revisionWidgetImpl->getDateTime();
         if (!txt.isEmpty()) {
            param += ":"+txt;
         }
      }
   }
   
  return param;
}

bool UpdateOtherRevisionStdDialogImpl::useStickyTag() {
  return (revisionWidgetImpl->isHeadSet() || revisionWidgetImpl->isStickySet());
}

bool UpdateOtherRevisionStdDialogImpl::resetStickyTag() {
  return revisionWidgetImpl->isHeadSet();
}

void UpdateOtherRevisionStdDialogImpl::setStickyTagToggled(bool state) {
  if (!state) {
    showWarning();
  }
}

void UpdateOtherRevisionStdDialogImpl::showWarning() {
  QString txt = tr(
    "Updating without setting sticky tags is dangerous!<br>"
    "If no revision/tag is specified, the main trunk is assumed. "
    "To make sure all files are reverted to exactly what you want "
    "requires manually setting a regular tag and specifying this as "
    "the tag to update to.<br>"
    "Carefully watch the cvs output and make sure "
    "cvs really does what you want.");
  QMessageBox::information(this,tr("Warning"),txt,QMessageBox::Ok);
}

void UpdateOtherRevisionStdDialogImpl::okClicked() {
  accept();
}

void UpdateOtherRevisionStdDialogImpl::enterWhatsThisMode()
{
   QWhatsThis::enterWhatsThisMode();
}

